"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
    return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (_) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
Object.defineProperty(exports, "__esModule", { value: true });
var collection_1 = require("./collection");
var v4_1 = require("uuid/v4");
var utils = require("./utils");
var utils_1 = require("./utils");
var NOTION_BASE_URL = "https://www.notion.so";
var Notabase = /** @class */ (function () {
    function Notabase(options) {
        this.utils = utils;
        this.blockStore = {};
        this.collectionSchemaStore = {};
        this.collectionStore = {};
        var proxy = options.proxy, token = options.token;
        // proxy > browser env + cloudflare worker
        // token > node env
        if (proxy) {
            var url_1 = proxy.url, authCode_1 = proxy.authCode;
            // browser env
            this.url = url_1; // cloudflare worker url
            // auth code for cloudflare worker (nobody knows but you ,same to the code that config in cf-worker)
            // without authCode you can only retrieve and cannot creat/update/delete
            this.authCode = authCode_1;
            this.reqeust = {
                post: function (path, data) {
                    return __awaiter(this, void 0, void 0, function () {
                        var r;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, fetch("" + url_1 + path + "?body=" + JSON.stringify(data), {
                                        method: 'GET',
                                        headers: {
                                            'content-type': 'application/json;charset=UTF-8',
                                            'x-auth-code': authCode_1,
                                        }
                                    })];
                                case 1:
                                    r = _a.sent();
                                    return [4 /*yield*/, r.json()];
                                case 2: return [2 /*return*/, _a.sent()];
                            }
                        });
                    });
                }
            };
        }
        else {
            // token node env 
            this.token = token;
            var tkHeader_1 = token ? { 'cookie': "token_v2=" + token } : {};
            var fetch_1 = require("node-fetch");
            // non-token browse ext env
            var credentials_1 = !token ? { credentials: 'include' } : {};
            this.reqeust = {
                post: function (path, data) {
                    return __awaiter(this, void 0, void 0, function () {
                        var r;
                        return __generator(this, function (_a) {
                            switch (_a.label) {
                                case 0: return [4 /*yield*/, fetch_1("" + NOTION_BASE_URL + path, __assign({ method: 'POST', headers: __assign({ 'accept-encoding': 'gzip, deflate', 'content-length': JSON.stringify(data).length, 'content-type': 'application/json;charset=UTF-8', 'user-agent': 'Mozilla/5.0 (Macintosh; Intel Mac OS X 10_13_6) AppleWebKit/537.36 (KHTML, like Gecko) Chrome/73.0.3683.103 Safari/537.36' }, tkHeader_1), body: JSON.stringify(data) }, credentials_1))];
                                case 1:
                                    r = _a.sent();
                                    return [4 /*yield*/, r.json()];
                                case 2: return [2 /*return*/, _a.sent()];
                            }
                        });
                    });
                }
            };
        }
    }
    Notabase.prototype.genId = function () {
        return v4_1.default();
    };
    Notabase.prototype.searchBlocks = function (fullTableID, query) {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.reqeust.post("/api/v3/searchBlocks", {
                            "query": query,
                            "table": "block",
                            "id": fullTableID,
                            "limit": 20
                        })];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data];
                }
            });
        });
    };
    Notabase.prototype.getBrowseableUrlByCollectionPageId = function (pageId) {
        return __awaiter(this, void 0, void 0, function () {
            var r, viewId, browseableUrl;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.getRecordValues([pageId], [])];
                    case 1:
                        r = _a.sent();
                        viewId = r[0].value[pageId].view_ids[0];
                        browseableUrl = "" + NOTION_BASE_URL + utils_1.getBlockHashId(pageId) + "?v=" + utils_1.getBlockHashId(viewId);
                        return [2 /*return*/, browseableUrl];
                }
            });
        });
    };
    Notabase.prototype.getRecordValues = function (blockIds, collectionIds) {
        return __awaiter(this, void 0, void 0, function () {
            var requestsIds, data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        requestsIds = __spreadArrays(blockIds.map(function (item) { return ({ "table": "block", "id": item }); }), collectionIds.map(function (item) { return ({ "table": "collection", "id": item }); }));
                        requestsIds.length > 10 ? console.log(">>>> getRecordValues: " + requestsIds.length) : console.log(">>>> getRecordValues:" + requestsIds);
                        return [4 /*yield*/, this.reqeust.post("/api/v3/getRecordValues", {
                                requests: requestsIds
                            })];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/, data.results];
                }
            });
        });
    };
    Notabase.prototype.loadPageChunk = function (pageId) {
        return __awaiter(this, void 0, void 0, function () {
            var data;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.reqeust.post("/api/v3/loadPageChunk", { "pageId": utils_1.getFullBlockId(pageId), "limit": 50, "cursor": { "stack": [] }, "chunkNumber": 0, "verticalColumns": false })];
                    case 1:
                        data = _a.sent();
                        return [2 /*return*/];
                }
            });
        });
    };
    Notabase.prototype.getPageCollectionInfo = function (pageId) {
        return __awaiter(this, void 0, void 0, function () {
            var data, collectionId, collectionViewId;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        console.log(">>>> getPageChunk:" + pageId);
                        return [4 /*yield*/, this.reqeust.post("/api/v3/loadPageChunk", { "pageId": utils_1.getFullBlockId(pageId), "limit": 50, "cursor": { "stack": [] }, "chunkNumber": 0, "verticalColumns": false })];
                    case 1:
                        data = _a.sent();
                        collectionId = Object.entries(data.recordMap.collection)[0][0];
                        collectionViewId = Object.entries(data.recordMap.collection_view)[0][0];
                        return [2 /*return*/, [collectionId, collectionViewId]];
                }
            });
        });
    };
    Notabase.prototype.queryCollection = function (collectionId, collectionViewId, limit) {
        if (limit === void 0) { limit = 980; }
        return __awaiter(this, void 0, void 0, function () {
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.reqeust.post("/api/v3/queryCollection", {
                            collectionId: collectionId,
                            collectionViewId: collectionViewId,
                            loader: {
                                "type": "table",
                                "limit": limit,
                                "userTimeZone": "Asia/Shanghai",
                                "userLocale": "zh-tw",
                                "loadContentCover": true
                            }
                        })];
                    case 1: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Notabase.prototype.fetchCollectionData = function (collectionId, collectionViewId, limit) {
        if (limit === void 0) { limit = 980; }
        return __awaiter(this, void 0, void 0, function () {
            var data, schema;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0: return [4 /*yield*/, this.queryCollection(collectionId, collectionViewId, limit)];
                    case 1:
                        data = _a.sent();
                        console.log(">>>> queryCollection:" + collectionId);
                        schema = data.recordMap.collection[collectionId].value.schema;
                        this.collectionSchemaStore[collectionId] = schema;
                        return [4 /*yield*/, new collection_1.Collection(collectionId, collectionViewId, data, this)];
                    case 2: return [2 /*return*/, _a.sent()];
                }
            });
        });
    };
    Notabase.prototype.fetch = function (urlOrPageId) {
        return __awaiter(this, void 0, void 0, function () {
            var collectionId, collectionViewId, pageId, _a, base, params, baseUrlList, r;
            var _b, _c;
            return __generator(this, function (_d) {
                switch (_d.label) {
                    case 0:
                        if (!urlOrPageId.match("^[a-zA-Z0-9-]+$")) return [3 /*break*/, 2];
                        return [4 /*yield*/, this.getPageCollectionInfo(utils_1.getBlockHashId(urlOrPageId))];
                    case 1:
                        // pageId with '-' split
                        // pageId = getBlockHashId(urlOrPageId)
                        _b = _d.sent(), collectionId = _b[0], collectionViewId = _b[1];
                        return [3 /*break*/, 4];
                    case 2:
                        if (!urlOrPageId.startsWith("http")) return [3 /*break*/, 4];
                        _a = urlOrPageId.split('?'), base = _a[0], params = _a[1];
                        baseUrlList = base.split('/');
                        return [4 /*yield*/, this.getPageCollectionInfo(baseUrlList[baseUrlList.length - 1])];
                    case 3:
                        _c = _d.sent(), collectionId = _c[0], collectionViewId = _c[1];
                        _d.label = 4;
                    case 4: return [4 /*yield*/, this.fetchCollectionData(collectionId, collectionViewId)
                        // this.collectionStore[pageId] = r
                    ];
                    case 5:
                        r = _d.sent();
                        // this.collectionStore[pageId] = r
                        return [2 /*return*/, r];
                }
            });
        });
    };
    Notabase.prototype.fetchAll = function (dbMap) {
        return __awaiter(this, void 0, void 0, function () {
            var db, requests, res;
            var _this = this;
            return __generator(this, function (_a) {
                switch (_a.label) {
                    case 0:
                        db = {};
                        requests = Object.entries(dbMap).map(function (item) {
                            var tableName = item[0], url = item[1];
                            db[tableName] = {};
                            return _this.fetch(url);
                        });
                        return [4 /*yield*/, Promise.all(requests)];
                    case 1:
                        res = _a.sent();
                        Object.entries(dbMap).map(function (item, index) {
                            var tableName = item[0], url = item[1];
                            db[tableName] = res[index];
                        });
                        return [2 /*return*/, db];
                }
            });
        });
    };
    Notabase.prototype.fetchConfig = function (url, _a) {
        var key = _a.key, value = _a.value;
        return __awaiter(this, void 0, void 0, function () {
            var dbMap, config;
            return __generator(this, function (_b) {
                switch (_b.label) {
                    case 0:
                        dbMap = {};
                        return [4 /*yield*/, this.fetch(url)];
                    case 1:
                        config = _b.sent();
                        config.rows.map(function (r) {
                            dbMap[r[key]] = r._raw.properties[config.propsKeyMap[value].key][0][1][0][1];
                        });
                        return [2 /*return*/, dbMap];
                }
            });
        });
    };
    return Notabase;
}());
exports.Notabase = Notabase;
